<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="generator" content="https://txt2tags.org">
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
</hgroup>
</header>


<div class="body">

<section>
<h1>Formatando strings multibyte com printf</h1>

<p>
<strong><em>Colaboração: Paulo Roberto Bagatini</em></strong>
</p>
<p>
<strong><em>Data de Publicação:</em></strong>
</p>
<p>
Tenho um projeto em <em>shell</em> chamado <code>shellect</code> (<a href="http://gitlab.com/arkanon/bash/shellect">http://gitlab.com/arkanon/bash/shellect</a>) onde me deparei com a necessidade de alinhar verticalmente caracteres quando as linhas possuem caracteres multibyte, como <code>ó</code> ou 🤓, por exemplo.
</p>
<p>
Apesar de ser um tanto improvável encontrar caracteres assim em um nome de diretório no Unix/Linux/BSD (ainda que tecnicamente possível), vou usar isso como desculpa para introduzir o assunto.
</p>
<p>
Começamos garantindo que temos instalada uma fonte monoespaçada com emojis gráficos que será (ou pelo menos espera-se que seja) usada pelo terminal. Se ainda não estava, após instalada pode ser necessário reiniciar o terminal.
</p>

<pre class="comandos">
$ sudo apt install fonts-noto-color-emoji
</pre>

<p>
Vamos lá:
</p>

<pre class="comandos">
$ mkdir multibyte
$ cd multibyte
$ mkdir ó 🤓

$ LANG=pt_BR.utf8 ls -1
<span class="saida">ó</span>
<span class="saida">🤓</span>

$ LANG=C ls -1
<span class="saida">''$'\303\263'</span>
<span class="saida">''$'\360\237\244\223'</span>

$ LANG=C ls -1 --quoting-style=shell
<span class="saida">??</span>
<span class="saida">????</span>

$ LANG=C ls -1 --quoting-style=shell --show-control-chars
<span class="saida">ó</span>
<span class="saida">🤓</span>

$ LANG=C ls -1 --quoting-style=escape
<span class="saida">\303\263</span>
<span class="saida">\360\237\244\223</span>

$ estilos='literal locale shell shell-always shell-escape shell-escape-always c escape'
$ dir=ó
$ for i in $estilos; { printf '  %-21s' $i; LANG=C ls -d --quoting-style=$i $dir; }
<span class="saida">  literal              ??</span>
<span class="saida">  locale               '\303\263'</span>
<span class="saida">  shell                ??</span>
<span class="saida">  shell-always         '??'</span>
<span class="saida">  shell-escape         ''$'\303\263'</span>
<span class="saida">  shell-escape-always  ''$'\303\263'</span>
<span class="saida">  c                    "\303\263"</span>
<span class="saida">  escape               \303\263</span>
</pre>

<p>
Na listagem acima vemos “coisas estranhas”.
</p>
<p>
Em <em>locale</em> <code>pt_BR.utf8</code>, tudo certo. O “problema” aparece em <em>locale</em> <code>C</code>, que não suporta UTF-8 e portanto a codificação das <em>strings</em> acaba sendo apresentada como uma sequência de números octais, que é uma forma possível para ele representar os caracteres na codificação original (UTF-8). Listando em estilo <em>shell</em>, vemos duas interrogações no diretório <code>ó</code> e 4 no 🤓. Adicionando o parâmetro <code>--show-control-chars</code> voltamos a ver os caracteres corretamente, mas ainda percebe-se que o <code>ó</code> ocupa uma coluna na tela enquanto o 🤓 ocupa duas.
</p>
<p>
Por quê?
</p>
<p>
Criamos um vetor com alguma <em>strings</em> que ocupam visualmente a mesma quantidade de colunas na tela em fonte monoespaçada:
</p>

<pre class="comandos">
$ multibyte=(
<span class="saida">    'oo  oo'</span>
<span class="saida">    'oo  oó'</span>
<span class="saida">    'oo  óó'</span>
<span class="saida">    'oo  o✓'</span>
<span class="saida">    'oo  🤓'</span>
<span class="saida">    'oó  óó'</span>
<span class="saida">    'óó  óó'</span>
<span class="saida">    'óó  🤓'</span>
<span class="saida">    '🤓  🤓'</span>
<span class="saida">  )</span>
</pre>

<p>
A primeira observação é que o caractere 🤓 DE FATO ocupa duas colunas. O Unicode, ao estender o conjunto de caracteres ASCII, abrangeu classes que exigem mais espaço físico para serem impressos.
</p>
<p>
Agora observamos o resultado de um loop que utiliza o <code>printf</code> para deixar todas as <em>strings</em> do vetor com 11 colunas de largura:
</p>

<pre class="comandos">
$ set "${multibyte[@]}"

$ for i; { printf "(%-11s)\n" "$i"; }
<span class="saida">(oo  oo     )</span>
<span class="saida">(oo  oó    )</span>
<span class="saida">(oo  óó   )</span>
<span class="saida">(oo  o✓   )</span>
<span class="saida">(oo  🤓   )</span>
<span class="saida">(oó  óó  )</span>
<span class="saida">(óó  óó )</span>
<span class="saida">(óó  🤓 )</span>
<span class="saida">(🤓  🤓 )</span>
</pre>

<p>
Só a primeira <em>string</em>, formada apenas por <code>o</code>’s minúsculos não acentuados, teve o resultado esperado. As outras formaram um carnaval de desalinhamento… 🫤
</p>
<p>
Como o <code>printf</code> leva em consideração apenas a quantidade de bytes das <em>strings</em> na formatação <code>%[N]s</code>, usá-lo com base apenas na quantidade de colunas desejadas é inefetivo para formatação de <em>strings</em> unicode. Esse comportamento com caracteres multibyte pode ser considerado um pequeno pesadelo: cada linha é retornada com um <em>padding</em> diferente e aparentemente aleatório de espaços em branco, apesar da “largura” na tela ser a mesma.
</p>
<p>
Mas existe uma forma bastante razoável de resolver isso em <em>shell</em>.
</p>
<p>
Vamos analisar essas várias <em>strings</em> com o comando <code>wc</code>:
</p>

<pre class="comandos">
$ wc --help | grep [mcL],
<span class="saida">  -c, --bytes            mostra a quantidade de bytes</span>
<span class="saida">  -m, --chars            mostra a quantidade de caracteres</span>
<span class="saida">  -L, --max-line-length  emite o comprimento da linha mais longa</span>

$ for i
<span class="saida">  {</span>
<span class="saida">    read m c L &lt;&lt;&lt; $(printf "$i" | wc -mcL)</span>
<span class="saida">    printf "%s %2s %s (%-11s)\n" $m $c $L "$i"</span>
<span class="saida">  }</span>
<span class="saida">6  6 6 (oo  oo     )</span>
<span class="saida">6  7 6 (oo  oó    )</span>
<span class="saida">6  8 6 (oo  óó   )</span>
<span class="saida">6  8 6 (oo  o✓   )</span>
<span class="saida">5  8 6 (oo  🤓   )</span>
<span class="saida">6  9 6 (oó  óó  )</span>
<span class="saida">6 10 6 (óó  óó )</span>
<span class="saida">5 10 6 (óó  🤓 )</span>
<span class="saida">4 10 6 (🤓  🤓 )</span>
</pre>

<p>
A terceira coluna da saída, resultado do parâmetro <code>-L</code> do <code>wc</code>, mostra que as <em>strings</em> ocupam visualmente a mesma quantidade de colunas no terminal, apesar de formadas por quantidades diferentes de caracteres (primeira coluna, parâmetro <code>-m</code>). A diferença entre elas, estruturalmente falando, é a quantidades de bytes (caracteres ASCII propriamente ditos) que cada uma ocupa, como mostra a segunda coluna, do parâmetro <code>-c</code>.
</p>
<p>
Podemos “ver” a estrutura desses caracteres. Eles podem ser entendidos como uma sequencia de caracteres ASCII…
</p>

<pre class="comandos">
$ printf o | od -An -tx1
<span class="saida"> 6f</span>
$ echo -e '\x6f'
<span class="saida">o</span>

$ printf ó | od -An -tx1
<span class="saida"> c3 b3</span>
$ echo -e '\xc3\xb3'
<span class="saida">ó</span>

$ printf ✓ | od -An -tx1
<span class="saida"> e2 9c 93</span>
$ echo -e '\xe2\x9c\x93'
<span class="saida">✓</span>

$ printf 🤓 | od -An -tx1
<span class="saida"> f0 9f a4 93</span>
$ echo -e '\xf0\x9f\xa4\x93'
<span class="saida">🤓</span>
</pre>

<p>
… ou caracteres propriamente ditos na codificação Unicode; no exemplo abaixo, de 32 bits (4 bytes):
</p>

<pre class="comandos">
$ printf o | iconv -t UTF-32LE | od -An -tx4
<span class="saida"> 0000006f</span>
$ echo -e '\U6f'
<span class="saida">o</span>

$ printf ó | iconv -t UTF-32LE | od -An -tx4
<span class="saida"> 000000f3</span>
$ echo -e '\Uf3'
<span class="saida">ó</span>

$ printf ✓ | iconv -t UTF-32LE | od -An -tx4
<span class="saida"> 00002713</span>
$ echo -e '\U2713'
<span class="saida">✓</span>

$ printf 🤓 | iconv -t UTF-32LE | od -An -tx4
<span class="saida"> 0001f913</span>
$ echo -e '\U1f913'
<span class="saida">🤓</span>
</pre>

<p>
O pulo do gato, então, é perceber que o erro da formatação do <code>printf</code> pode ser compensado adicionando ao valor da largura desejada (11), a diferença entre a quantidade de bytes que forma a <em>string</em> (dada pelo <code>-c</code> do <code>wc</code>) e a quantidade de colunas do terminal que a <em>string</em> ocupa (dada pelo <code>-L</code>):
</p>

<pre class="comandos">
$ for i
<span class="saida">  {</span>
<span class="saida">    read c L &lt;&lt;&lt; $(printf "$i" | wc -cL)</span>
<span class="saida">    printf "(%-$((11+c-L))s)\n" "$i"</span>
<span class="saida">  }</span>
<span class="saida">(oo  oo     )</span>
<span class="saida">(oo  oó     )</span>
<span class="saida">(oo  óó     )</span>
<span class="saida">(oo  o✓     )</span>
<span class="saida">(oo  🤓     )</span>
<span class="saida">(oó  óó     )</span>
<span class="saida">(óó  óó     )</span>
<span class="saida">(óó  🤓     )</span>
<span class="saida">(🤓  🤓     )</span>
</pre>

<p>
Talvez na tela que você esteja lendo esse texto o alinhamento dos <code>)</code> acima não seja perfeito, mas isso é devido à renderização do seu <em>software</em>. Num terminal texto eles ficarão perfeitamente alinhados na vertical:
</p>
<p>
<img class="center" src="screenshot.png" alt="">
</p>

<section>
<h2>Um pouco de água fria</h2>

<p>
Para nossa tristeza, enquanto alguns caracteres ocupam 2 colunas para serem mostrados e os programas identificam isso, outros precisam de mais mas isso é ignorado.
</p>
<p>
O caractere ﷽ (Basmala, expressão árabe que significa “Em nome de Deus, o Mais Gracioso, o Mais Misericordioso”), por exemplo, mesmo também sendo codificado em 4 bytes (<code>\U0000fdfd</code>) precisa 12 (doze!) colunas na tela, mas tanto o <code>wc</code> quanto o terminal reconhecem apenas 1.
</p>
<p>
<img class="center" src="basmala.png" alt="">
</p>
<p>
É bem provável que os sistemas de renderização de texto que usamos para ler esse texto apresentem adequadamente o caractere mesmo em fonte monoespaçada:
</p>

<pre class="comandos">
$ printf '1234567890123\n﷽\n'
<span class="saida">1234567890123</span>
<span class="saida">﷽</span>

$ printf '﷽' | wc -cL
<span class="saida">      3       1</span>

$ i=﷽🤓
$ read c L &lt;&lt;&lt; $(printf "$i" | wc -cL)
$ printf "(%-$((11+c-L))s)\n" "$i"
<span class="saida">(﷽🤓        )</span>
</pre>

<p>
Mas por enquanto, o que conseguimos na maioria dos terminais e editores de texto é algo como:
</p>
<p>
<img class="center" src="wider.png" alt="">
</p>
<p>
Essa idiossincrasia está relacionada à incapacidade do <em>software</em> de manipular as características gráficas dos caracteres unicode mais novos. Assim como os caracteres que exigem 2 colunas antigamente ficavam mal representados no terminal e alguns editores de código, eventualmente os que exigem 3 ou mais colunas virão a ser adequadamente representados em algum momento futuro. Até lá, o <code>printf</code> vai continuar apresentando resultados inconsistentes se algum deles estiver presente na <em>string</em> a ser formatada…
</p>

</section>
<section>
<h2>Referências</h2>

 <ul>
 <li><a href="https://sriramadasvijay-medium-com.translate.goog/what-is-utf-8-utf-16-utf-32-d6d52f1f2ec7?_x_tr_sl=auto&amp;_x_tr_tl=pt">O que é UTF-8, UTF-16, UTF-32?</a>
 </li>
 <li><a href="https://www-joelonsoftware-com.translate.goog/2003/10/08/the-absolute-minimum-every-software-developer-absolutely-positively-must-know-about-unicode-and-character-sets-no-excuses/?_x_tr_sl=auto&amp;_x_tr_tl=pt">O mínimo absoluto que todo desenvolvedor de software deve saber absolutamente e positivamente sobre Unicode e conjuntos de caracteres (sem desculpas!)</a>
 </li>
 <li><a href="https://design215.com/toolbox/utf8-4byte-characters.php">UTF-8 4-byte Character Chart</a>
 </li>
 <li><a href="https://compart.com/en/unicode/U+FDFD">Unicode Character “﷽” (U+FDFD)</a>
 </li>
 </ul>

</section>
<section>
<h2>Comandos usados nesse artigo</h2>

 <ul>
 <li><a href="http://man.he.net/?section=all&amp;topic=apt">apt</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=bash">bash</a>: <a href="http://gnu.org/software/bash/manual/bash.html#index-cd">cd</a>, <a href="http://gnu.org/software/bash/manual/bash.html#index-echo">echo</a>, <a href="http://gnu.org/software/bash/manual/bash.html#index-for">for</a>, <a href="http://gnu.org/software/bash/manual/bash.html#index-printf">printf</a>, <a href="http://gnu.org/software/bash/manual/bash.html#index-read">read</a>, <a href="http://gnu.org/software/bash/manual/bash.html#index-set">set</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=ls">ls</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=mkdir">mkdir</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=od">od</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=sudo">sudo</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=wc">wc</a>
 </li>
 <li><a href="http://man.he.net/?section=all&amp;topic=iconv">iconv</a>
 </li>
 </ul>

</section>
</section>
</div>
</body></html>
